//+------------------------------------------------------------------+
//|                                                    Zee Zee i.mq4 |
//|                                Copyright  2007, Carlos J. Rivas |
//|                                                 carlos@vealo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Carlos J. Rivas"
#property link      "carlos@vealo.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color5 Yellow
#property indicator_color4 CLR_NONE
#property indicator_color3 CLR_NONE
#property indicator_color2 CLR_NONE
#property indicator_color1 Chocolate
#property indicator_color6 Red
#property indicator_level1 100
#property indicator_level2 -100
#property indicator_levelcolor DimGray

//---- input parameters
extern int CCIPeriod=14;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;
//---- buffers
double CCIBuffer[];
double CCIBufferHi[];
double CCIBufferLow[];
double RelBuffer[];
double DevBuffer[];
double MovBuffer[];
double trend[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,CCIBuffer);
   SetIndexBuffer(1, RelBuffer);
   SetIndexBuffer(2, DevBuffer);
   SetIndexBuffer(3, MovBuffer);
   SetIndexBuffer(4, CCIBufferHi);
   SetIndexBuffer(5, CCIBufferLow);
   SetIndexBuffer(6, trend);
   SetIndexLabel(0,"ZZI("+CCIPeriod+")");
   IndicatorShortName("ZZI("+CCIPeriod+")");
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   double mul=0.015/CCIPeriod;
   for(int i=limit; i>=0; i--)
   {
      MovBuffer[i]=iMA(NULL,0,CCIPeriod,0,MODE_SMA,PRICE_TYPICAL,i);
      double sum=0.0;
      for (int k=0; k<CCIPeriod && (i+k)<Bars; k++)
                      sum   += MathAbs((High[i+k]+Low[i+k]+Close[i+k])/3-MovBuffer[i]);
       DevBuffer[i] = sum*mul;
       double price=(High[i]+Low[i]+Close[i])/3;
            RelBuffer[i]    = price-MovBuffer[i];
            CCIBuffer[i]    = (DevBuffer[i]==0.0) ? 0 : RelBuffer[i]/DevBuffer[i];
            CCIBufferHi[i]  = (CCIBuffer[i] >=  100) ? CCIBuffer[i] : EMPTY_VALUE;
            CCIBufferLow[i] = (CCIBuffer[i] <= -100) ? CCIBuffer[i] : EMPTY_VALUE;
            trend[i]        = (i<Bars-1) ? trend[i+1] : 0;
               if (CCIBuffer[i]>= 100)                    trend[i] =  1;
               if (CCIBuffer[i]<=-100)                    trend[i] = -1;
               if (CCIBuffer[i]>-100 && CCIBuffer[i]<100) trend[i] =  0;
   }

   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {

         if (trend[whichBar] ==  1)                          doAlert(whichBar," level 100 up");
         if (trend[whichBar] == -1)                          doAlert(whichBar," level -100 down");
         if (trend[whichBar] ==  0 && trend[whichBar+1]== 1) doAlert(whichBar," level 100 down");
         if (trend[whichBar] ==  0 && trend[whichBar+1]==-1) doAlert(whichBar," level -100 up");
      }
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
 
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cci crossed",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Zee Zee cci"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

